#include "mainwindow.h"
#include "ui_mainwindow.h"
#include<QMessageBox>
#include<QSqlQuery>
#include<QTimer>
#include<QTime>
#include<QDebug>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    QTime time = QTime::currentTime();
    QString Time = time.toString();
    qDebug()<<Time;
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButton_Open_clicked()
{
    com = ui->comboBox->currentText();
    link();
}
void MainWindow::link()
{
    struct PortSettings myComeSetting ={BAUD9600,DATA_8,PAR_NONE,STOP_1,FLOW_OFF,500};
    myCom = new Win_QextSerialPort(com,myComeSetting,QextSerialBase::EventDriven);
    myCom->open(QIODevice::ReadWrite);
    connect(myCom,SIGNAL(readyRead()),this,SLOT(readMyCom()));
    QMessageBox::about(NULL,"ɹ","򿪴ڳɹ");
}
void MainWindow::on_pushButton_Close_clicked()
{
    myCom->close();
    delete myCom;
    myCom = NULL;
}
void MainWindow::Clear()
{
    ui->textBrowser->clear();
}
void MainWindow::Check()
{
    QSqlQuery query;
    QString Xu;
    Xu = ui->textBrowser->toPlainText();
    query.exec(QString("select * from TEST where XULIEHAO = '%1'").arg(Xu));
    if(query.next())
    {
        QTime time = QTime::currentTime();
        QString Time = time.toString();
        int num = query.value(4).toInt();
        num = num + 1;
        query.exec(QString("update TEST set TIMES = %1 where XULIEHAO = '%2'").arg(num).arg(Xu));
        query.exec(QString("update TEST set TIME = '%1' where XULIEHAO = '%2'").arg(Time).arg(Xu));
        Display();
        Clear();
    }else{
        QMessageBox::critical(0,"ʧ",
                              "δҵû",
                                      QMessageBox::Cancel);
        Clear();
    }
}
void MainWindow::readMyCom()
{
    QString buf;
    temp = myCom->readAll();
    if(!temp.isEmpty()){
    for(int i = 0; i < temp.count(); i++){
       QString s;
        s.sprintf("0x%02x ", (unsigned char)temp.at(i));
        buf += s;
    }

    ui->textBrowser->setText(ui->textBrowser->document()->toPlainText() + buf);
    QTextCursor cursor = ui->textBrowser->textCursor();
    cursor.movePosition(QTextCursor::End);
    ui->textBrowser->setTextCursor(cursor);
    Check();
}
}
void MainWindow::Display()
{
    QSqlQuery query;
    QString Xu;
    QString Name;
    QString BM;
    QString Time;
    Xu= ui->textBrowser->toPlainText();
    query.exec(QString("select * from TEST where XULIEHAO = '%1'").arg(Xu));
    if(query.next()){
        Name = query.value(0).toString();
        BM = query.value(1).toString();
        Time = query.value(5).toString();
        qDebug()<<Name;
        ui->textBrowser_2->setText(QString("%1 %2 %3").arg(Name).arg(BM).arg(Time));
        Clear();
    }
    //ui->textBrowser_2->setPlainText(Name);
}
