#ifndef CONNECTION_H
#define CONNECTION_H

#include<QSqlDatabase>
#include<QtNetwork>
#include<QString>
#include<QMessageBox>

static bool createConnection()
{
    QSqlDatabase db = QSqlDatabase::addDatabase("QODBC");
    QString host = QHostInfo::localHostName();
    QString dsn = QString("DRIVER={SQL SERVER};SERVER=%1;DATABASE=denglu;").arg(host);
    db.setDatabaseName(dsn);
    if(!db.open()){
        QMessageBox::critical(0,"Cannot open database",
                              "Unable to establish a databaseconnection",
                              QMessageBox::Cancel);
    }
    return true;

}


#endif // CONNECTION_H
