#include "mainwindow.h"
#include "ui_mainwindow.h"
#include<QComboBox>
#include<QMessageBox>
#include<QSqlQuery>
#include<QTime>
#include<QTimer>
#include<QDebug>
MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButton_Open_clicked()
{
    com = ui->comboBox->currentText();
    link();
}
void MainWindow::link()
{
    struct PortSettings myComeSetting ={BAUD9600,DATA_8,PAR_NONE,STOP_1,FLOW_OFF,500};
    myCom = new Win_QextSerialPort(com,myComeSetting,QextSerialBase::EventDriven);
    myCom->open(QIODevice::ReadWrite);
    connect(myCom,SIGNAL(readyRead()),this,SLOT(readMyCom()));
    QMessageBox::about(NULL,"ɹ","򿪴ڳɹ");
}
void MainWindow::readMyCom()
{
    QString buf;
    QByteArray  temp = myCom->readAll();
    if(!temp.isEmpty()){
    for(int i = 0; i < temp.count(); i++){
       QString s;
        s.sprintf("0x%02x ", (unsigned char)temp.at(i));
        buf += s;
    }

    ui->textBrowser->setText(ui->textBrowser->document()->toPlainText() + buf);
    QTextCursor cursor = ui->textBrowser->textCursor();
    cursor.movePosition(QTextCursor::End);
    ui->textBrowser->setTextCursor(cursor);

}
}

void MainWindow::on_pushButton_Insert_clicked()
{
      QString NAME;
      QString BUMEN;
      QString ID;
      QString Xu;
      QTime time = QTime::currentTime();
      QString Time = time.toString();
      qDebug()<<Time;
      NAME = ui->lineEdit_Name->text();
      BUMEN = ui->lineEdit_BM->text();
      ID = ui->lineEdit_ID->text();
      Xu = ui->textBrowser->toPlainText();
      QSqlQuery query;
      query.exec(QString("insert into TEST values ('%1','%2',%3,'%4',1,'%5')").arg(NAME).arg(BUMEN).arg(ID).arg(Xu).arg(Time));
      QMessageBox::about(NULL, "ɹ", "ûɹ");
      Clear();
}

void MainWindow::on_pushButton_Close_clicked()
{
    myCom->close();
    delete myCom;
    myCom = NULL;
}
void MainWindow::Clear()
{
    ui->lineEdit_BM->clear();
    ui->lineEdit_ID->clear();
    ui->lineEdit_Name->clear();
    ui->textBrowser->clear();
}

void MainWindow::on_pushButton_Clear_clicked()
{
    Clear();
}
