#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include"win_qextserialport.h"

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

private:
    Ui::MainWindow *ui;
    Win_QextSerialPort *myCom;
    QString com;

private slots:
    void on_pushButton_Clear_clicked();
    void on_pushButton_Close_clicked();
    void on_pushButton_Insert_clicked();
    void on_pushButton_Open_clicked();
    void link();
    void readMyCom();
    void Clear();
};

#endif // MAINWINDOW_H
